(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('@nonoll/code-snippet/browser', ['exports'], factory) :
    (global = global || self, factory((global.nonoll = global.nonoll || {}, global.nonoll['code-snippet'] = global.nonoll['code-snippet'] || {}, global.nonoll['code-snippet'].browser = {})));
}(this, (function (exports) { 'use strict';

    /**
     * browser ios 유무 반환
     * @memberof module:browser
     * @example
     * import { isAOS } from 'fe-code-snippet/browser';
     * console.log(isAOS);
     * @returns boolean
     */
    var isAOS = function () {
        return /Android/.test(window.navigator.userAgent);
    };

    // @see https://davidwalsh.name/vendor-prefix
    var prefix = (function () {
        var styles = window.getComputedStyle(window.document.documentElement);
        var pre = (Array.from(styles).join('').match(/-(moz|webkit|ms)-/) || (styles.OLink === '' && ['', 'o']))[1];
        var dom = ('Webkit|Moz|MS|O').match(new RegExp("(" + pre + ")", 'i'))[1];
        return {
            dom: dom,
            lowercase: pre,
            css: "-" + pre + "-",
            js: pre[0].toUpperCase() + pre.substr(1)
        };
    })();

    exports.isAOS = isAOS;
    exports.prefix = prefix;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nonoll-code-snippet-browser.umd.js.map
