(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('@nonoll/code-snippet', ['exports'], factory) :
    (global = global || self, factory((global.nonoll = global.nonoll || {}, global.nonoll['code-snippet'] = {})));
}(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * browser ios 유무 반환
     * @memberof module:browser
     * @example
     * import { isAOS } from 'fe-code-snippet/browser';
     * console.log(isAOS);
     * @returns boolean
     */
    var isAOS = function () {
        return /Android/.test(window.navigator.userAgent);
    };

    // @see https://davidwalsh.name/vendor-prefix
    var prefix = (function () {
        var styles = window.getComputedStyle(window.document.documentElement);
        var pre = (Array.from(styles).join('').match(/-(moz|webkit|ms)-/) || (styles.OLink === '' && ['', 'o']))[1];
        var dom = ('Webkit|Moz|MS|O').match(new RegExp("(" + pre + ")", 'i'))[1];
        return {
            dom: dom,
            lowercase: pre,
            css: "-" + pre + "-",
            js: pre[0].toUpperCase() + pre.substr(1)
        };
    })();

    /*
     * Public API Surface of @nonoll/code-snippet/browser
     */

    var publicApi_browser = /*#__PURE__*/Object.freeze({
        __proto__: null,
        isAOS: isAOS,
        prefix: prefix
    });

    function noop() { }

    var EventEmitter = /** @class */ (function () {
        function EventEmitter() {
            this.events = [];
        }
        EventEmitter.prototype.on = function (eventName, listener, context) {
            if (listener === void 0) { listener = noop; }
            this.events.push({ eventName: eventName, listener: listener, context: context });
            return this;
        };
        EventEmitter.prototype.off = function (eventName, listener) {
            var matched = this.events.findIndex(function (regEvent) { return regEvent.eventName === eventName && (listener ? regEvent.listener === listener : true); });
            if (!~matched) {
                return;
            }
            this.events.splice(matched, 1);
            return this;
        };
        EventEmitter.prototype.once = function (eventName, listener, context) {
            var _this = this;
            if (listener === void 0) { listener = noop; }
            var onceWrapper = function () {
                var values = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    values[_i] = arguments[_i];
                }
                _this.off(eventName, onceWrapper);
                listener.apply(context || listener, values);
            };
            this.on(eventName, onceWrapper, context);
            return this;
        };
        EventEmitter.prototype.emit = function (eventName) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                values[_i - 1] = arguments[_i];
            }
            this.events.forEach(function (regEvent) {
                if (regEvent.eventName === eventName) {
                    regEvent.listener.apply(regEvent.context || regEvent.listener, values);
                }
            });
            return this;
        };
        EventEmitter.prototype.fire = function (eventName) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                values[_i - 1] = arguments[_i];
            }
            this.emit(eventName, values);
            return this;
        };
        return EventEmitter;
    }());

    /*
     * Public API Surface of @nonoll/code-snippet/event
     */

    var publicApi_event = /*#__PURE__*/Object.freeze({
        __proto__: null,
        EventEmitter: EventEmitter
    });

    var debounce = function (fn, delay) {
        var timer;
        delay = delay || 0;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            window.clearTimeout(timer);
            timer = window.setTimeout(function () {
                fn.apply(null, args);
            }, delay);
        };
    };

    var throttle = function (fn, delay) {
        delay = delay || 0;
        var caller = function (args) {
            fn.apply(null, args);
            base = +new Date();
        };
        var base = null;
        var isLeading = true;
        var stamp = null;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (isLeading) {
                caller(args);
                isLeading = false;
                return;
            }
            stamp = +new Date();
            base = base || stamp;
            if ((stamp - base) >= delay) {
                caller(args);
            }
        };
    };

    /*
     * Public API Surface of @nonoll/code-snippet/functions
     */

    var publicApi_functions = /*#__PURE__*/Object.freeze({
        __proto__: null,
        debounce: debounce,
        noop: noop,
        throttle: throttle
    });

    /**
     * MutationRecordType
     * @export
     * @readonly
     * @enum {string}
     * @see https://developer.mozilla.org/ko/docs/Web/API/MutationObserver#MutationObserverInit
     */
    var MutationRecordType;
    (function (MutationRecordType) {
        MutationRecordType["childList"] = "childList";
        MutationRecordType["attributes"] = "attributes";
        MutationRecordType["characterData"] = "characterData";
        MutationRecordType["subtree"] = "subtree";
    })(MutationRecordType || (MutationRecordType = {}));
    /**
     * MutationEvent Types
     * @export
     * @readonly
     * @enum {string}
     */
    var MUTATION_EVENTS;
    (function (MUTATION_EVENTS) {
        /** change childList */
        MUTATION_EVENTS["CHANGE_CHILD_LIST"] = "MUTATION_OBERSERVER-EVENTS-CHANGE_CHILD_LIST";
        /** change subtree */
        MUTATION_EVENTS["CHANGE_SUBTREE"] = "MUTATION_OBERSERVER-EVENTS-CHANGE_SUBTREE";
        /** change attributes */
        MUTATION_EVENTS["CHANGE_ATTRIBUTES"] = "MUTATION_OBERSERVER-EVENTS-CHANGE_ATTRIBUTES";
        /** change characterData */
        MUTATION_EVENTS["CHANGE_CHARACTER_DATA"] = "MUTATION_OBERSERVER-EVENTS-CHANGE_CHARACTER_DATA";
        /** change other case */
        MUTATION_EVENTS["CHANGE"] = "MUTATION_OBERSERVER-EVENTS-CHANGE";
        /** change wildcard - all case */
        MUTATION_EVENTS["WILD_CARD"] = "MUTATION_OBERSERVER-EVENTS-CHANGE_WILCD_CARD";
    })(MUTATION_EVENTS || (MUTATION_EVENTS = {}));
    var PureMutationObserver = /** @class */ (function () {
        function PureMutationObserver(callback) {
            // TODO polyfill
            // const MutationObserver = require('mutation-observer');
            // this.pure = new MutationObserver(callback);
            this.pure = new window.MutationObserver(callback);
        }
        PureMutationObserver.prototype.observe = function (target, options) {
            this.pure.observe(target, options);
        };
        PureMutationObserver.prototype.disconnect = function () {
            this.pure.disconnect();
        };
        return PureMutationObserver;
    }());
    /**
     * @export
     * @class MutationObserver
     * @extends EventEmitter
     * @see https://developer.mozilla.org/ko/docs/Web/API/MutationObserver
     * @see https://github.com/webmodules/mutation-observer
     * @example
     * import { MutationObserver, MUTATION_EVENTS } from '@nonoll/my-lib/observer';
     *
     * const createElement = ({ tag = 'div', id = '', style = '', value = '', text = '' }) => {
     *  const doc = window.document;
     *  const target = doc.createElement(tag);
     *  target.setAttribute('id', id);
     *  target.setAttribute('style', style);
     *  target.setAttribute('value', value);
     *  if (text) {
     *    target.textContent = text;
     *  }
     *  return target;
     * }
     *
     * const forExample = () => {
     *  const doc = window.document;
     *
     *  const attachButton = createElement({ tag: 'button', text: 'observer attach' });
     *  const detachButton = createElement({ tag: 'button', text: 'observer detach' });
     *  const appendButton = createElement({ tag: 'button', text: 'append' });
     *
     *  doc.body.appendChild(attachButton);
     *  doc.body.appendChild(detachButton);
     *  doc.body.appendChild(appendButton);
     *
     *  attachButton.addEventListener('click', e => {
     *    e.preventDefault();
     *    console.log('attachButton clicked');
     *    if (!observer) {
     *      return;
     *    }
     *    observer.attach();
     *  });
     *
     *  detachButton.addEventListener('click', e => {
     *    e.preventDefault();
     *    console.log('detachButton clicked');
     *    if (!observer) {
     *      return;
     *    }
     *    observer.detach();
     *  });
     *
     *  appendButton.addEventListener('click', e => {
     *    e.preventDefault();
     *    console.log('appendButton clicked');
     *    if (!observer) {
     *      return;
     *    }
     *    const input = createElement({ tag: 'input', value: `${+new Date()}` });
     *    target.appendChild(input);
     *  });
     * }
     *
     * const target = createElement({ id: 'example_target', style: 'border: 1px solid red' });
     * window.document.body.appendChild(target);
     *
     * const options = {
     *  childList: true,
     *  subtree: true
     * };
     *
     * const observer = new MutationObserver({ target, options });
     * observer.on(MUTATION_EVENTS.WILD_CARD, (type, values) => {
     *  console.log('wildCard', type, values);
     * }).on(MUTATION_EVENTS.CHANGE_CHILD_LIST, values => {
     *  console.log('childList', values);
     * });
     * observer.attach();
     *
     * forExample();
     */
    var MutationObserver = /** @class */ (function (_super) {
        __extends(MutationObserver, _super);
        function MutationObserver(_a) {
            var _b = _a.target, target = _b === void 0 ? null : _b, _c = _a.debounce, debounce$1 = _c === void 0 ? 300 : _c, _d = _a.callback, callback = _d === void 0 ? noop : _d, _e = _a.options, options = _e === void 0 ? {} : _e;
            var _this = _super.call(this) || this;
            var defaultOptions = { childList: true, subtree: true };
            _this.target = target;
            _this.options = Object.assign({}, defaultOptions, options);
            _this.onMutationObserverListener = _this.onMutationObserverListener.bind(_this);
            _this.callback = callback || noop;
            if (debounce$1) {
                _this.observer = new PureMutationObserver(debounce(_this.onMutationObserverListener, debounce$1));
            }
            else {
                _this.observer = new PureMutationObserver(_this.onMutationObserverListener);
            }
            return _this;
        }
        MutationObserver.prototype.attach = function () {
            this.observer.observe(this.target, this.options);
            return this;
        };
        MutationObserver.prototype.onMutationObserverListener = function (mutations) {
            var _this = this;
            mutations.forEach(function (mutation) {
                var type = mutation.type;
                var values = { type: type, mutation: mutation };
                switch (type) {
                    case MutationRecordType.childList:
                        _this.callback(values);
                        _this.emit(MUTATION_EVENTS.CHANGE_CHILD_LIST, values);
                        _this.emit(MUTATION_EVENTS.WILD_CARD, type, values);
                        break;
                    case MutationRecordType.subtree:
                        _this.callback(values);
                        _this.emit(MUTATION_EVENTS.CHANGE_SUBTREE, values);
                        _this.emit(MUTATION_EVENTS.WILD_CARD, type, values);
                        break;
                    case MutationRecordType.attributes:
                        _this.callback(values);
                        _this.emit(MUTATION_EVENTS.CHANGE_ATTRIBUTES, values);
                        _this.emit(MUTATION_EVENTS.WILD_CARD, type, values);
                        break;
                    case MutationRecordType.characterData:
                        _this.callback(values);
                        _this.emit(MUTATION_EVENTS.CHANGE_CHARACTER_DATA, values);
                        _this.emit(MUTATION_EVENTS.WILD_CARD, type, values);
                        break;
                    default:
                        _this.callback(values);
                        _this.emit(MUTATION_EVENTS.CHANGE, type, values);
                        _this.emit(MUTATION_EVENTS.WILD_CARD, type, values);
                        break;
                }
            });
        };
        MutationObserver.prototype.detach = function () {
            if (this.observer) {
                this.observer.disconnect();
            }
            return this;
        };
        MutationObserver.prototype.destroy = function () {
            this.detach();
            this.observer = null;
            return this;
        };
        return MutationObserver;
    }(EventEmitter));

    var doc = window.document;
    function getVendorPrefix() {
        var prefix = '';
        if (typeof doc.hidden !== 'undefined') {
            prefix = '';
        }
        else if (typeof doc.msHidden !== 'undefined') {
            prefix = 'ms';
        }
        else if (typeof doc.webkitHidden !== 'undefined') {
            prefix = 'webkit';
        }
        return prefix;
    }
    var VENDOR_PREFIX = getVendorPrefix();
    var VISIBILITY_EVENT_NAME = VENDOR_PREFIX + "visibilitychange";
    var HIDDEN_METHOD_NAME = VENDOR_PREFIX ? VENDOR_PREFIX + "Hidden" : 'hidden';
    var VISIBILITY_EVENTS;
    (function (VISIBILITY_EVENTS) {
        VISIBILITY_EVENTS["CHANGE"] = "VISIBILITY_CHANGE-EVENTS-CHANGE";
        VISIBILITY_EVENTS["GET_STATUS"] = "VISIBILITY_CHANGE-EVENTS-GET_STATUS";
    })(VISIBILITY_EVENTS || (VISIBILITY_EVENTS = {}));
    var VisibilityChangeObserver = /** @class */ (function (_super) {
        __extends(VisibilityChangeObserver, _super);
        function VisibilityChangeObserver() {
            var _this = _super.call(this) || this;
            if (!VisibilityChangeObserver.isSupportVisibilityChange()) {
                throw new Error('VisibilityChange 지원되지 않는 브라우저입니다.');
            }
            _this.onVisibilityChangeListener = _this.onVisibilityChangeListener.bind(_this);
            return _this;
        }
        VisibilityChangeObserver.visibilityEventName = function () {
            return VENDOR_PREFIX + "visibilitychange";
        };
        VisibilityChangeObserver.hiddenMethodName = function () {
            return VENDOR_PREFIX ? VENDOR_PREFIX + "Hidden" : 'hidden';
        };
        VisibilityChangeObserver.isSupportVisibilityChange = function () {
            return typeof doc[VisibilityChangeObserver.hiddenMethodName()] !== 'undefined';
        };
        VisibilityChangeObserver.prototype.onVisibilityChangeListener = function () {
            var isHidden = this.isHidden();
            this.emit(VISIBILITY_EVENTS.CHANGE, { isHidden: isHidden, isShow: !isHidden });
        };
        VisibilityChangeObserver.prototype.isHidden = function () {
            return doc[VisibilityChangeObserver.hiddenMethodName()];
        };
        VisibilityChangeObserver.prototype.getStatus = function () {
            this.emit(VISIBILITY_EVENTS.GET_STATUS);
            return this;
        };
        VisibilityChangeObserver.prototype.attach = function () {
            if (!doc.addEventListener) {
                return;
            }
            doc.addEventListener(VisibilityChangeObserver.visibilityEventName(), this.onVisibilityChangeListener, false);
            this.on(VISIBILITY_EVENTS.GET_STATUS, this.onVisibilityChangeListener);
            return this;
        };
        VisibilityChangeObserver.prototype.detach = function () {
            if (!doc.addEventListener) {
                return;
            }
            doc.removeEventListener(VisibilityChangeObserver.visibilityEventName(), this.onVisibilityChangeListener, false);
            this.off(VISIBILITY_EVENTS.GET_STATUS, this.onVisibilityChangeListener);
            return this;
        };
        VisibilityChangeObserver.prototype.destroy = function () {
            this.detach();
            return this;
        };
        return VisibilityChangeObserver;
    }(EventEmitter));

    /*
     * Public API Surface of @nonoll/code-snippet/observer
     */

    var publicApi_observer = /*#__PURE__*/Object.freeze({
        __proto__: null,
        get MutationRecordType () { return MutationRecordType; },
        get MUTATION_EVENTS () { return MUTATION_EVENTS; },
        MutationObserver: MutationObserver,
        getVendorPrefix: getVendorPrefix,
        VENDOR_PREFIX: VENDOR_PREFIX,
        VISIBILITY_EVENT_NAME: VISIBILITY_EVENT_NAME,
        HIDDEN_METHOD_NAME: HIDDEN_METHOD_NAME,
        get VISIBILITY_EVENTS () { return VISIBILITY_EVENTS; },
        VisibilityChangeObserver: VisibilityChangeObserver
    });

    /*
     * Public API Surface of @nonoll/code-snippet/types
     */

    var publicApi_types = /*#__PURE__*/Object.freeze({
        __proto__: null
    });

    exports.browser = publicApi_browser;
    exports.event = publicApi_event;
    exports.functions = publicApi_functions;
    exports.observer = publicApi_observer;
    exports.types = publicApi_types;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nonoll-code-snippet.umd.js.map
