/**
 * browser ios 유무 반환
 * @memberof module:browser
 * @example
 * import { isAOS } from 'fe-code-snippet/browser';
 * console.log(isAOS);
 * @returns boolean
 */
var isAOS = function () {
    return /Android/.test(window.navigator.userAgent);
};

// @see https://davidwalsh.name/vendor-prefix
var prefix = (function () {
    var styles = window.getComputedStyle(window.document.documentElement);
    var pre = (Array.from(styles).join('').match(/-(moz|webkit|ms)-/) || (styles.OLink === '' && ['', 'o']))[1];
    var dom = ('Webkit|Moz|MS|O').match(new RegExp("(" + pre + ")", 'i'))[1];
    return {
        dom: dom,
        lowercase: pre,
        css: "-" + pre + "-",
        js: pre[0].toUpperCase() + pre.substr(1)
    };
})();

/*
 * Public API Surface of @nonoll/code-snippet/browser
 */

/**
 * Generated bundle index. Do not edit.
 */

export { isAOS, prefix };
//# sourceMappingURL=nonoll-code-snippet-browser.js.map
